// pages/myFollow/myFollow.js
const api = require('../../api/index')
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    menu:[
      {
        label:'收藏的专利',
        method:'selectCollectPatent'
      }
    ],
    queryParams:{
      current:1,
      size:10
    },
    total:0,
    tableData:[],
    checkList:[
      {
        type:"-1",
        label:'全部',
        icon:'',
        checked:true
      },
      {
        type:"1",
        label:'白名单',
        icon:'myIconanquanbangzhu',
        checked:false
      },
      {
        type:"2",
        label:'灰名单',
        icon:'myIconicon-test',
        checked:false
      },
      {
        type:"0",
        label:'黑名单',
        icon:'myIcongroup43',
        checked:false
      },
    ],
    checked:[],
    active:null,
    triggered:false,
    load:false,
    hasMore:true,
    showPopup:false, 
    changeFollow:false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    if(options.type == 0 || options.type){
      if(options.type != -1){
        this.setData(
          {
            checked:[options.type]
          }
        )
      }else{
        this.init()
      }
      this.setData(
        {
          active:options.type
        }
      )
    }else{
      this.init()
    }
    
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {
    
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },


  /**
   * 页面功能
   */
  //关注和监控
  closePopup(e){
    this.setData(
      {
        showPopup:false
      }
    )
    wx.nextTick(() => {
      this.setData({ changeFollow: false }) // 在当前同步流程结束后，下一个时间片执行
    })
   },
   openPopup(e){
    console.log(e)
    this.setData(
      {
        showPopup:true
      }
    )
    if(e.detail && e.detail.changeFollow){
      this.setData(
        {
          changeFollow:true
        }
      )
    }
   },
   attention(e){
    const childComponent = this.selectComponent('#myProduct');
    // var {type} = e.detail
    if (childComponent) {  
      childComponent.attention(e); // 调用子组件的方法  
    }
   },
   cancelFollow2(e){
    const childComponent = this.selectComponent('#myProduct');
    // var {type} = e.detail
    if (childComponent) {  
      childComponent.cancelFollow(e); // 调用子组件的方法  
    }
   },


  //初始化加载
  init(){
    var params = {
      current:1,
      size:10
    }
    this.setData(
      {
        queryParams:params,
        total:0,
        tableData:[],
        hasMore:true
      }
    )
    this.getMyFollowProductList()
  },

  //下拉刷新
  onRefresh() {
    console.log('onRefresh')
    this.setData({
      triggered: true,
    })
    this.init()
  },
  //取消关注
  cancelFollow(e){
    var index = e.detail
    var data = this.data.tableData
    data.splice(index,1)
    this.setData(
      {
        tableData:data
      }
    )
    this.getMyFollowProductList(1)
  },
  //获取关注的产品
  getMyFollowProductList(type){
    var params = {
      ...this.data.queryParams,
      concernTypes:this.data.checked
    }
    wx.showLoading({
      title: '加载中',
    })
    api.queryConcernProduct(params).then(res=>{
      if(res.code == 200){
        var data = this.data.tableData
        wx.hideLoading()
        if(type){
            var startIndex = (this.data.queryParams.current-1)*this.data.queryParams.size
            var endIndex = data.length
            var len = endIndex - startIndex
            data.splice(startIndex,len,...res.data.data)
        }else{
            data = data.concat(res.data.data)
        }
        
        
        this.setData(
          {
            tableData:data,
            total:res.data.total,
            triggered: false,
            load:false
          }
        )
        if(this.data.total<=data.length){
          this.setData({
            hasMore:false
          })
        }
        api.notify(
          {
            type:'success',
            message:'查询成功',
            top:wx.getStorageSync('height')
          }
        )
      }
    }).catch(error=>{
      wx.hideLoading()
      this.setData({
        triggered: false,
        load:false
      })
    })
  },
  //加载更多
  loadMore(){
    var current = this.data.queryParams.current
    this.setData(
      {
        ['queryParams.current']:current+1,
        load :true
      }
    )
    this.getMyFollowProductList()
  },
  //获取筛选值
  onChange(e){
    // var data = e.detail
    var {name,title} = e.detail
    var data = []
    if(name != -1){
      data = [name]
    }
    
    this.setData({
      checked: data,
    });
    this.init()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})